const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const academic_years = sequelize.define(
    'academic_years',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

start_date: {
        type: DataTypes.DATE,
      
      

      },

end_date: {
        type: DataTypes.DATE,
      
      

      },

current: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  academic_years.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity








    db.academic_years.hasMany(db.terms, {
      as: 'terms_academic_year',
      foreignKey: {
          name: 'academic_yearId',
      },
      constraints: false,
    });









    db.academic_years.hasMany(db.classes, {
      as: 'classes_academic_year',
      foreignKey: {
          name: 'academic_yearId',
      },
      constraints: false,
    });
















//end loop



    db.academic_years.belongsTo(db.schools, {
      as: 'school',
      foreignKey: {
        name: 'schoolId',
      },
      constraints: false,
    });




    db.academic_years.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.academic_years.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return academic_years;
};


